<script setup lang="ts">
defineProps({
  headerText: {
    type: String,
    required: false,
    default: 'More to explore',
  },
  ctaText: {
    type: String,
    required: false,
    default: 'View all blog posts',
  },
  readMoreText: {
    type: String,
    required: false,
    default: 'Read more',
  },
  posts: {
    type: Array,
    required: true,
  },
});
</script>

<template>
  <div class="wrapper">
    <div class="header">
      <SlpTypography v-if="headerText" variant="heading2-bold" tag="h2">
        {{ headerText }}
      </SlpTypography>
      <SlpButton
        v-if="ctaText"
        variant="tertiary"
        class="header-cta"
        href="/blog/"
        data-ga-location="resources"
        :data-ga-name="ctaText"
      >
        {{ ctaText }}
        <!-- <SlpIcon name="chevron-right" variant="product" /> -->
      </SlpButton>
    </div>
    <div v-if="posts?.length > 0" class="cards">
      <a
        v-for="post in posts"
        :key="post.title"
        class="card"
        data-ga-location="resources"
        :data-ga-name="post.title"
        :href="`/blog/${post.slug}`"
      >
        <div v-if="post.category?.name" class="category">
          <!-- <SlpIcon name="blog" variant="marketing" /> -->
          <SlpTypography v-if="post.category?.name" variant="body2" tag="p">{{ post.category?.name }}</SlpTypography>
        </div>
        <NuxtImg v-if="post.heroImage" :src="`${post.heroImage}`" alt="" />
        <SlpTypography v-if="post.title" variant="heading5-bold" tag="h4" class="title">{{ post.title }}</SlpTypography>
        <SlpButton v-if="readMoreText" variant="tertiary"
          >{{ readMoreText }}
          <!-- <SlpIcon name="chevron-right" variant="product" /> -->
        </SlpButton>
      </a>
    </div>
    <div v-else>
      No related posts right now - this will change when there are more posts in the CMS with the same category as this
      current post!
    </div>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  margin: 64px auto;
  @media (min-width: $breakpoint-lg) {
    margin: 96px auto;
  }
}
.header {
  display: flex;
  justify-content: space-between;
  margin-bottom: 24px;
  @media (max-width: $breakpoint-lg) {
    flex-direction: column;
  }
  &-cta {
    white-space: nowrap;
  }
}
.cards {
  display: grid;
  grid-template-columns: 1fr;
  gap: 30px;
  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(3, 1fr);
  }

  .card {
    cursor: pointer;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    gap: 16px;
    color: $color-text-300;
    padding: 16px;
    .title {
      flex-basis: 100%;
    }
    .category {
      display: flex;
      gap: 8px;
      align-items: center;
    }
    img {
      width: 318px;
      height: 222px;
      min-height: 222px;
      object-fit: cover;
      @media (max-width: $breakpoint-lg) {
        max-width: 100%;
      }
    }
    &:hover {
      background-color: #f6f3fe;
      transition:
        background 0.3s ease,
        border-radius 0.3s ease !important;
      border-radius: 8px 8px 50px 8px;
    }
  }
}
</style>
